From e5bba4b81d2d35ce3caffc382273b488647df27b Mon Sep 17 00:00:00 2001
From: Arthur BOUDREAULT <arthur@lydra.fr>
Date: Mon, 24 Jan 2022 10:33:39 +0100
Subject: [PATCH] refactor: add default value + template script is no longer
 DRY

---
 README-FR.md                   |  2 +-
 README.md                      |  2 +-
 tasks/autoupdate.yml           |  4 ++--
 templates/ynh_autoupdate.sh.j2 | 28 +++++++++++-----------------
 4 files changed, 15 insertions(+), 21 deletions(-)

diff --git a/README-FR.md b/README-FR.md
index 0644a77..b9a3068 100644
--- a/README-FR.md
+++ b/README-FR.md
@@ -148,7 +148,7 @@ Une tâche cron peut être mise en place pour automatiser la vérification des m
   Pour en savoir plus sur les _special times_, cliquez [ici](https://docs.ansible.com/ansible/latest/collections/ansible/builtin/cron_module.html).
   - `ynh_autoupdate.apps` : est indispensable. Activez la mise à jour automatique des applications Yunohost en mettant la valeur à `True`.
   - `ynh_autoupdate.system` : est indispensable. Activez la mise à jour automatique du système Yunohost en mettant la valeur à `True`.
-  - `ynh_autoupdate.dest_script` est obligatoire. Il s'agit du répertoire où le fichier de template va être stocké.
+  - `ynh_autoupdate.dest_script` : c'est le chemin du répertoire où le script de mise à jour sera installé sur le serveur. La valeur par défaut est `/usr/local/bin`.
 
 Si des mises à jour sont disponibles, elles sont faites automatiquement. En cas de problème suite à la mise à jour d'une application, vous pouvez lire les logs qui sont disponibles ici `/var/log/yunohost/categories/operation`. Vous avez aussi la possibilité de revenir à la version précédente car Yunohost fait toujours une sauvegarde automatique d'une application lorsqu'elle est mise à jour. 
 
diff --git a/README.md b/README.md
index 8154e48..b56ab30 100644
--- a/README.md
+++ b/README.md
@@ -148,7 +148,7 @@ A cron job can been set up to automate the check for system and application upda
   - `ynh_autoupdate.special_time`: it is mandatory. It allows you to specify when you want this task to be executed. Possible values: (`annually`,`daily`,`hourly`,`monthly`,`reboot`,`weekly`,`yearly`). To learn more about special times, click [here](https://docs.ansible.com/ansible/latest/collections/ansible/builtin/cron_module.html).
   - `ynh_autoupdate.apps`: is required. Enable automatic updating of Yunohost applications by setting the value to `True`.
   - `ynh_autoupdate.system`: is required. Enable automatic updating of the Yunohost system by setting the value to `True`.
-  - `ynh_autoupdate.dest_script` is mandatory. This is the directory where the template script will be stored.
+  - `ynh_autoupdate.dest_script`: it is the path to the directory where the update script will be installed on the server. The default value is `/usr/local/bin`.
 
 If available, updates are done automatically. In case of problems following an application update, you can read logs located in `/var/log/yunohost/categories/operation` . You also have the possibility to rollback to the previous version since Yunohost always makes an automatic backup of an application when it is updated. 
 
diff --git a/tasks/autoupdate.yml b/tasks/autoupdate.yml
index d0ec3e1..0f1e552 100644
--- a/tasks/autoupdate.yml
+++ b/tasks/autoupdate.yml
@@ -21,7 +21,7 @@
 - name: Creates Yunohost autoupdate script
   ansible.builtin.template:
     src: "templates/ynh_autoupdate.sh.j2"
-    dest: "{{ ynh_autoupdate.dest_script }}"
+    dest: "{{ ynh_autoupdate.dest_script | default('/usr/local/bin') }}"
     owner: root
     group: root
     mode: '0740'
@@ -32,5 +32,5 @@
           Logs can be found in /var/log/yunohost/categories/operation"
     special_time: "{{ ynh_autoupdate.special_time }}"
     user: root
-    job: "{{ ynh_autoupdate.dest_script }}"
+    job: "{{ ynh_autoupdate.dest_script | default('/usr/local/bin') }}"
     cron_file: ynh_autoupdate_cron
diff --git a/templates/ynh_autoupdate.sh.j2 b/templates/ynh_autoupdate.sh.j2
index 05df184..27e77bb 100644
--- a/templates/ynh_autoupdate.sh.j2
+++ b/templates/ynh_autoupdate.sh.j2
@@ -1,20 +1,14 @@
 #!/bin/sh
 
-{% if ynh_autoupdate.apps and ynh_autoupdate.system %}
-yunohost tools update && \
-yunohost tools upgrade system && \
-yunohost tools upgrade apps
-
-{% elif ynh_autoupdate.apps %}
-yunohost tools update && \
-yunohost tools upgrade apps
-
-{% elif ynh_autoupdate.system %}
-yunohost tools update && \
-yunohost tools upgrade system
-
-{% else %}
-echo "Read the readme to know more about ynh_autoupdate.apps and ynh_autoupdate.system"
-echo "https://lab.frogg.it/lydra/yunohost/ansible-yunohost/-/blob/main/README.md"
-exit 1
+yunohost tools update
+{% if ynh_autoupdate.system %}
+    yunohost tools upgrade system
+{% endif %}
+{% if ynh_autoupdate.apps %}
+    yunohost tools upgrade apps
+{% endif %}
+{% if ynh_autoupdate.system is false and ynh_autoupdate.apps is false %}
+    echo "Read the readme to know more about ynh_autoupdate.apps and ynh_autoupdate.system"
+    echo "https://lab.frogg.it/lydra/yunohost/ansible-yunohost/-/blob/main/README.md"
+    exit 1
 {% endif %}
-- 
GitLab